(function () {
    "use strict";

    angular.module('core').controller('fornecedorPessoaFisicaDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$state', '$stateParams', 'contatoService', 'empresaService'];

    function controller($scope, $timeout, $state, $stateParams, contatoService, empresaService) {
        $scope.initializeLayout('Fornecedor Pessoa Física');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
        };
        $scope.popups = {
            empresas: { ativo: false },
            andamentos: { ativo: false },
        };
        $scope.auxiliar = {
            empresas: { data: [], carregando: false, vazio: true, count: 0, args: { filtro: { ContatoPrincipal: { ID: decodeURIComponent($stateParams.id) } }, skip: 0, take: 999999 } },
            andamentos: { data: [], carregando: false, vazio: true, count: 0, args: {} },
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            contatoService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.item = response.Data;
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.get();
        };

        $scope.toggleEmpresas = function () {
            $scope.popups.empresas.ativo = !$scope.popups.empresas.ativo;
            if ($scope.popups.empresas.ativo) {
                $scope.getAllEmpresa();
            }
        };
        $scope.toggleAndamentos = function () {
            $scope.popups.andamentos.ativo = !$scope.popups.andamentos.ativo;
        };

        $scope.getAllEmpresa = function () {
            $scope.auxiliar.empresas.carregando = true;
            $scope.auxiliar.empresas.vazio = false;
            empresaService
                .getAll($scope.auxiliar.empresas.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            console.error(response.Exception);
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.auxiliar.empresas.data);
                        }
                        $scope.auxiliar.empresas.carregando = false;
                        $scope.auxiliar.empresas.vazio = !response.Data.length;
                    },
                    function (_error) {
                        $scope.auxiliar.empresas.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    });
        }

        /*Inicializa funções*/
        $scope.initialize();

    }

})();